//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation

extension TBX.AuthorizationService {

    /** Get the list of rules to override the IDP response's */
    public enum AuthorizationServiceGetRulesToOverrideResponse {

        public static let service = APIService<Response>(id: "AuthorizationService.getRulesToOverrideResponse", tag: "AuthorizationService", method: "GET", path: "/AuthorizationServices/overrideRules", hasBody: false, securityRequirements: [])

        public final class Request: APIRequest<Response> {

            public init() {
                super.init(service: AuthorizationServiceGetRulesToOverrideResponse.service)
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [OverrideRuleObject]

            /** Request was successful */
            case status200([OverrideRuleObject])

            /** Bad Request  */
            case status400(ErrorObject)

            /** Unauthorized  */
            case status401(ErrorObject)

            /** Customer or Device not Found */
            case status404(ErrorObject)

            /** Device was Logged Out or the customer not longer exists */
            case status410(ErrorObject)

            public var success: [OverrideRuleObject]? {
                switch self {
                case .status200(let response): return response
                default: return nil
                }
            }

            public var failure: ErrorObject? {
                switch self {
                case .status400(let response): return response
                case .status401(let response): return response
                case .status404(let response): return response
                case .status410(let response): return response
                default: return nil
                }
            }

            /// either success or failure value. Success is anything in the 200..<300 status code range
            public var responseResult: APIResponseResult<[OverrideRuleObject], ErrorObject> {
                if let successValue = success {
                    return .success(successValue)
                } else if let failureValue = failure {
                    return .failure(failureValue)
                } else {
                    fatalError("Response does not have success or failure response")
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                case .status400(let response): return response
                case .status401(let response): return response
                case .status404(let response): return response
                case .status410(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                case .status400: return 400
                case .status401: return 401
                case .status404: return 404
                case .status410: return 410
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                case .status400: return false
                case .status401: return false
                case .status404: return false
                case .status410: return false
                }
            }

            public init(statusCode: Int, data: Data, decoder: ResponseDecoder) throws {
                switch statusCode {
                case 200: self = try .status200(decoder.decode([OverrideRuleObject].self, from: data))
                case 400: self = try .status400(decoder.decode(ErrorObject.self, from: data))
                case 401: self = try .status401(decoder.decode(ErrorObject.self, from: data))
                case 404: self = try .status404(decoder.decode(ErrorObject.self, from: data))
                case 410: self = try .status410(decoder.decode(ErrorObject.self, from: data))
                default: throw APIClientError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
